Ext.define('DSS.component.Wizard', {
    extend : 'Ext.window.Window',

    /** Textfield holding the event name */
    editControls : {},
    buttonStart : null,
    buttonNext : null,
    buttonFinish : null,
    buttonCancel : null,
    buttonBack: null,
    innerHeight : 427,
    makeControl : function(subConfig) {
        var oControl;
        switch (subConfig.type) {
            /*case 'combobox' : {
            	
            	oControl = Ext.create('DSS.component.ComboboxControl', {
            		data:subConfig.data,
            		labelWidth:subConfig.labelWidth,
            		storevalueid:subConfig.storevalueid,
            		storedisplayid:subConfig.storedisplayid,
            		label:subConfig.label,
            		storeid:subConfig.storeid,
                    myID:subConfig.id,
                    allowBlank : subConfig.allowBlank
                });

                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                
                break;
            }
            case 'radio' : {
            	
            	oControl = Ext.create('DSS.component.RadioControl', {
            		data:subConfig.data,            		
            		labelWidth:subConfig.labelWidth,
            		label:subConfig.label,
            		radioid:subConfig.id,
                    myID:subConfig.id
                });

            	
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27 * subConfig.data.length;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                
                break;
            }*/
            case 'hidden': {
                var oPseudoControl = {
                    value : null
                };
                oPseudoControl.setValue = function(oValue) {
                    this.value = oValue;
                };
                oPseudoControl.reset = function(oValue) {
                    this.value = null;
                };
                oPseudoControl.getValue = function() {
                    return this.value;
                };
                oPseudoControl.isValid = function() {
                    return true;
                };
                this.editControls[subConfig.id] = oPseudoControl;
                return null;
                break;
            }
            case 'custom': {
                oControl = subConfig.control;
                if ((subConfig.flex == null) || (!subConfig.flex)) {
                	try  {
                		var iHeight=oControl.getHeight();
                		this.innerHeight -= iHeight;
                	} 
                	catch (e) {
                        this.innerHeight -= 22;
                	}
                }
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
/*
            case 'timespan': {
                oControl = Ext.create('DSS.component.TimeSpanControl', {
                    name : subConfig.id,
            		labelWidth:subConfig.labelWidth,
                    fieldLabel : subConfig.label,
                    hideHour: subConfig.hideHour,
                    hideMinute:subConfig.hideMinute,
                    hideSecond:subConfig.hideSecond,
                    withEnabler:subConfig.withEnabler,
                    myID:subConfig.id
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 32;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;

                return oControl;
                break;
            }
            case 'deviceSelection': {
                oControl = Ext.create('DSS.component.DeviceSelector', {
                    filterFunc:subConfig.filterFunc,
                    specialDeviceRenderer:subConfig.specialDeviceRenderer,
                    myID:subConfig.id,
                    bMultiselect: subConfig.multiselect
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'number': {
                oControl = Ext.create('Ext.form.field.Number', {
                    name : subConfig.id,
                    allowBlank : false,
                    blankText : _('This field is required'),
                    invalidText : _('The value in this field is invalid'),
                    fieldLabel : subConfig.label,
                    width : 200,
                    step : 1,
                    value : 0,
                    minValue : subConfig.minValue,
                    maxValue : subConfig.maxValue,
                    myID:subConfig.id
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'groupbox': {
                var oSubcontrols = [];
                if (subConfig.content != null)
                    for ( var iIndex = 0; iIndex < subConfig.content.length; iIndex++)
                        oSubcontrols.push(this.makeControl(subConfig.content[iIndex]),finTab);

                oControl = Ext.create('Ext.form.FieldSet', {
                    title : subConfig.label,
                    items : oSubcontrols,
                    padding: "0 5 10 0",
                    margin: 5
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27;

                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'checkbox': {
                oControl = Ext.create('Ext.form.field.Checkbox', {
                    name : subConfig.id,
                    fieldLabel : subConfig.title,
                    boxLabel : subConfig.label,
                    allowBlank : false,
                    labelSeparator: ( subConfig.title=='&nbsp;')?'':':',
                            myID:subConfig.id
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 22;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'text': {
            	if (subConfig.labelWidth==null)
            		subConfig.labelWidth=100;
                oControl = Ext.create('DSS.component.Textedit', {
                    name : subConfig.id,
                    fieldLabel : subConfig.label,
            		labelWidth:subConfig.labelWidth,
                    allowBlank : false,
                    blankText : _('This field is required'),
                    invalidText : _('The value in this field is invalid'),
                    width : 600,
                    inputWidth : 500,
                    myID:subConfig.id
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'date': {
                oControl = Ext.create('DSS.component.Dateedit', {
                    name : subConfig.id,
                    fieldLabel : subConfig.label,
            		labelWidth:subConfig.labelWidth,
                    allowBlank : false,
                    width : 600,
                    myID:subConfig.id
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'weekdaySelection': {
                oControl = Ext.create('DSS.component.WeekdaySelection', {
                    name : subConfig.id,
            		labelWidth:subConfig.labelWidth,
                    label : subConfig.label,
                    width : 800,
                    myID:subConfig.id
                });
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 27;
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'ActionConfigurator': {
                oControl = Ext.create('DSS.component.ActionConfigurator', {
                    height : 350,
                    noHighlevel : subConfig.noHighlevel,
                    withDelay: subConfig.withDelay,
                    allowNoAction : subConfig.allowNoAction,
                    enableUsergroup:subConfig.enableUsergroup,
                    userStates:subConfig.userStates,
                    ignorePresence:subConfig.ignorePresence,
                    heatingOperationMode:subConfig.heatingOperationMode,
                    heatingExtendedOperationMode:subConfig.heatingExtendedOperationMode,
                    UMRExtendetFunctions:subConfig.UMRExtendetFunctions,
                    myID:subConfig.id
                });
                this.editControls[subConfig.id] = oControl;
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 350;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'ConditionConfigurator': {
                oControl = Ext.create('DSS.component.ConditionConfigurator', {
                    height : 350,
                    conditions:subConfig.conditions,
                    ignorePresence:subConfig.ignorePresence,
                    heatingOperationMode:subConfig.heatingOperationMode,
                    myID:subConfig.id
                });
                this.editControls[subConfig.id] = oControl;
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 350;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'TriggerConfigurator': {
                oControl = Ext.create('DSS.component.TriggerConfigurator', {
                    height : 350,
                    enableUsergroup:subConfig.enableUsergroup,
                    userStates:subConfig.userStates,
                    ignorePresence:subConfig.ignorePresence,
                    heatingOperationMode:subConfig.heatingOperationMode,
                    myID:subConfig.id
                });
                this.editControls[subConfig.id] = oControl;
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 350;
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'MessageControl': {
                oControl = Ext.create('DSS.component.MessageEditor', {
            		labelWidth:subConfig.labelWidth,
                    title : subConfig.title,
                    myID:subConfig.id
                });
                this.editControls[subConfig.id] = oControl;
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 150;
                
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'TitterMsgControl' : 
            {
                oControl = Ext.create('DSS.component.TitterMessageEditor', {
            		labelWidth:subConfig.labelWidth,
                    title : subConfig.title,
                    myID:subConfig.id
                });
                this.editControls[subConfig.id] = oControl;
                if ((subConfig.flex == null) || (!subConfig.flex))
                    this.innerHeight -= 150;
                
                oControl.dssEditor=this;
                return oControl;
                break;
            }
            case 'timeReference' :{
                oControl = Ext.create('DSS.component.TimeReference', {
                    name : subConfig.id,
            		labelWidth:subConfig.labelWidth,
                    label : subConfig.label,
                    width : 800,
                    randomize: subConfig.randomize,
                    additionalAbsoluteValues: subConfig.additionalAbsoluteValues,
                    referenceChangeListener:subConfig.referenceChangeListener,
                    myID:subConfig.id
                });
                if ((subConfig.flex == null) || (!subConfig.flex)) {
                    if (subConfig.randomize)
                        this.innerHeight -= (54 + 26);
                    else
                        this.innerHeight -= 54;                    
                }
                    
                this.editControls[subConfig.id] = oControl;
                oControl.dssEditor=this;
                return oControl;
                break;
            }*/
        }
        return Ext.create('Ext.panel.Panel', {
            border : '0'
        });
    },
    oStartPage:null,
    oPages:[],
    value:{},
    actIndex:0,
    pageDefinition:null,
    startLongTitle:null,
    validatePage: function () {
    	var fNext=true;
    	var pageDef=this.pageDefinition[this.actIndex];
    	if (pageDef!=null)
	    	for (var iIndex=0;iIndex<pageDef.controls.length;iIndex++) {
	    		var id=pageDef.controls[iIndex].id;
	    		if (this.editControls[id].isValid()==false)
	    			fNext=false;
	    	}
    	this.buttonNext.setDisabled(!fNext);
    	this.buttonFinish.setDisabled(!fNext);
    },
    takeOverValue:function() {
    	var pageDef=this.pageDefinition[this.actIndex];
    	for (var iIndex=0;iIndex<pageDef.controls.length;iIndex++) {
    		var id=pageDef.controls[iIndex].id;
    		this.value[id]=this.editControls[id].getValue();
    	}
    },
    constructor : function(config) {
        config.closeAction = 'hide';
        config.modal = true; 
        config.height = 500;
        config.width = 800;
        config.layout = 'fit';
        config.appName = '';
        config.resizable=false;

        this.editControls={};
        this.oPages=[];
        this.innerHeight = 427;
       
        this.addEvents({
        	change : true
        });
        
        var me = this;
        var sCancelText=_('cancel');
        if (config.cancelTitle!=null) {
            sCancelText=config.cancelTitle;
        }
        var sFinishText=_('finish');
        if (config.finishTitle!=null) {
        	sFinishText=config.finishTitle;
        }
        var sNextText=_('next');
        if (config.nextTitle!=null) {
        	sNextText=config.nextTitle;
        }
        var sStartText=_('start');
        if (config.startTitle!=null) {
        	sStartText=config.startTitle;
        }
        var sBackText=_('back');
        if (config.backTitle!=null) {
        	sBackText=config.backTitle;
        }
        if (config.startLongTitle!=null) {
        	this.startLongTitle=config.startLongTitle;
        }
        
        if ((config.hideBack==null) ||(config.hideBack==false)) { 
            me.buttonBack = Ext.create('Ext.Button', {
                text : sBackText,
                handler : function() {
                	me.setStep(me.actIndex-1);

                	var nextRecord=me.leftStore.findRecord('_id',me.actIndex+1,0,false,true,true);
            		if (nextRecord!=null)
            			me.leftPanel.getSelectionModel().select(nextRecord);
            		else
            			me.leftPanel.getSelectionModel().deselectAll();
                
                }
            });
        }
        if ((config.hideCancel==null) ||(config.hideCancel==false)) { 
            me.buttonCancel = Ext.create('Ext.Button', {
                text : sCancelText,
                handler : function() {
                    me.fireEvent('cancel');
                    me.hide();
                }
            });
        }
        if ((config.hideFinish==null) ||(config.hideFinish==false)) {
            me.buttonFinish = Ext.create('Ext.Button', {
                text : sFinishText,
                handler : function() {
                	me.takeOverValue();
            		me.pageDefinition.finishFunc(me.getValues());
                    me.hide();
                }
            });
        }
        if ((config.hideNext==null) ||(config.hideNext==false)) {
            me.buttonNext = Ext.create('Ext.Button', {
                text : sNextText,
                handler : function() {
                	me.takeOverValue();
                	me.setStep(me.actIndex+1);

                	var nextRecord=me.leftStore.findRecord('_id',me.actIndex+1,0,false,true,true);
            		if (nextRecord!=null)
            			me.leftPanel.getSelectionModel().select(nextRecord);
            		else
            			me.leftPanel.getSelectionModel().deselectAll();


                }
            });
        }
        if ((config.hideStart==null) ||(config.hideStart==false)) {
            me.buttonStart = Ext.create('Ext.Button', {
                text : sStartText,
                handler : function() {
                    me.setStep(0);
                	var nextRecord=me.leftStore.findRecord('_id',me.actIndex+1,0,false,true,true);
            		if (nextRecord!=null)
            			me.leftPanel.getSelectionModel().select(nextRecord);
            		else
            			me.leftPanel.getSelectionModel().deselectAll();

                }
            });
        }
        this.addEvents({
            cancel : true,
            finish : true
        });
        this.leftStore=Ext.create('Ext.data.Store', {
        	fields:['name','_id','value','definition'],
        	proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
        })
        
        if (config.startDescription != null) {
        	this.oStartPage=Ext.create('Ext.panel.Panel', {
        		border : 0,
        		width:676,
    			height:375,
    			html:config.startDescription
    		});
        }
        if (config.pages != null) {
        	this.pageDefinition=config.pages;
        	this.leftStore.add({
        		_id:-3,
        		name:'',
        		value:null        		
        	});
        	for (var iIndex=0;iIndex<config.pages.length;iIndex++) {
        		var pageDef=config.pages[iIndex];
        		this.leftStore.add({
        			definition:pageDef.definition,
        			name:pageDef.shortTitle,
        			_id:iIndex+1,
        			value:null});   
        		var items=[ {
    				xtype:'label',
    				text:pageDef.longDescription
    			}];
        		if (pageDef.controls!=null)
        			if (pageDef.controls.length>0) {
        				for(var kIndex=0;kIndex<pageDef.controls.length;kIndex++){
        					var oControl=this.makeControl(pageDef.controls[kIndex]);
        					oControl.on('change', function() {
        						me.validatePage();
        					});
        					
        					items.push(oControl);        					
        				}
        			}
        		var page=Ext.create('Ext.panel.Panel', {
        			border : 0,
        			width:676,
        			height:387,
        			items: items,
        			hidden:true
        		});
        		this.oPages.push(page);
        		
        		
        	}
        	this.leftStore.add({
        		_id:-2,
        		name:'',
        		value:null
        	});
        	this.leftStore.add({
        		_id:-1,
        		name:'Finish',
        		value:null
        	});
        	/*
        	this.oTabPanelParent = Ext.create('Ext.tab.Panel', {
                height : this.innerHeight
            });
            this.innerHeight -= 27;
            var tabbedHeight = this.innerHeight;
            for ( var iIndex = 0; iIndex < config.tabControls.length; iIndex++) {
                if (config.tabControls[iIndex].defaultTabOnNew!=null)
                    if (config.tabControls[iIndex].defaultTabOnNew)
                    	this.defaultFirstTabOnNew=iIndex;
                if (config.tabControls[iIndex].defaultTabOnEdit!=null)
                    if (config.tabControls[iIndex].defaultTabOnEdit)
                    	this.defaultFirstTabOnEdit=iIndex;


            	flexControl = null;
                this.innerHeight = tabbedHeight;
                if (config.tabControls[iIndex].content.length > 0) {
                    var oTabPanel = Ext.create('Ext.panel.Panel', {
                        title : config.tabControls[iIndex].tabLabel,
                        border : '0'
                    });
                    this.oTabPanels["" + iIndex]={panel:oTabPanel,title:config.tabControls[iIndex].tabLabel};
                    if (config.tabControls[iIndex].tabDescription!=null) {
                        
                        oTabPanel.add(Ext.create('Ext.form.field.Display', {
                            border : 0,
                            height:18,
                            value:config.tabControls[iIndex].tabDescription,
                            width:770,
                            margin: "7 0 10 5",
                            style: {
                                fontSize: '11px'
                            }
                        }));
                        this.innerHeight -= 35;
                    }
                    for ( var jIndex = 0; jIndex < config.tabControls[iIndex].content.length; jIndex++) {
                        var oControl = me.makeControl(config.tabControls[iIndex].content[jIndex],true);
                        if (oControl != null) {
                            oControl._myTabIndex = iIndex;
                            oTabPanel.add(oControl);
                            if (config.tabControls[iIndex].content[jIndex].flex)
                                flexControl = oControl;
                        }
                    }
                    this.oTabPanelParent.add(oTabPanel);
                    if (flexControl != null)
                        flexControl.setHeight(this.innerHeight);
                }
            }
            oStaticSubitems.push(this.oTabPanelParent);
            */
        } else {
        	/*
        	this.innerHeight -= 40;
            if (flexControl != null) {
                flexControl.setHeight(this.innerHeight);
            } else {
                    config.height=500-this.innerHeight;
            }
            */
        }
        
        this.displayBottomText=Ext.create('Ext.form.field.Display', {
            border : 0,
            value:'',
            style: {
                fontSize: '11px'
            },
            padding:'0 0 2 5',
            flex:1
        });
        var oButtons=[this.displayBottomText];
        	
        if (me.buttonStart!=null)
            oButtons.push(me.buttonStart);
        if (me.buttonBack!=null)
            oButtons.push(me.buttonBack);
        if (me.buttonNext!=null)
            oButtons.push(me.buttonNext);
        if (me.buttonFinish!=null)
            oButtons.push(me.buttonFinish);
        if (me.buttonCancel!=null)
            oButtons.push(me.buttonCancel);
        
        var insideItems=Ext.create("Ext.panel.Panel", {     
    		bodyPadding : 10,
    		border:"1px",
    		items:this.oPages
    	});
        insideItems.add(this.oStartPage);
    	insideItems.updateLayout();
        
        
        this.leftPanel=Ext.create('Ext.grid.Panel', {
        	store:this.leftStore,
        	border : 0,
        	hideHeaders:true,
        	columnLines:false,
        	rowLines:false,
        	viewConfig:{
        		stripeRows:false
        	},
        	columns: [{
        		dataIndex:name,
        		renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        			if (record.get('_id')==-1)
        				return record.get('name');
        			if (record.get('_id')==-2)
        				return '';
        			if (record.get('_id')==-3)
        				return '<div style="height:40px;"></div>';
        			return record.get('_id') + '. ' + record.get('name');
        		}
        	}],
        	width:100
        });
        
        this.leftPanel.on('beforeselect', function(grid, record) {
            if (record.get('_id')<0)
            	return false;
            if (record.get('definition')!=null)
	            if (record.get('definition').constrainFunc!=null)
	            	return record.get('definition').constrainFunc(record.get('_id'),me.value);
            return true;
        });
        
        this.leftPanel.on('beforeitemmouseenter', function(grid, record) {
            if (record.get('_id')<0)
            	return false;
            return true;
        });
        
        this.leftPanel.on('selectionchange',function(view, selections) {
        	if (selections.length==1) {
        		var index=selections[0].get('_id');
        		me.setStep(index-1);
        	}
        	
        });
        
        this.topIndicator=Ext.create('Ext.form.Label' , {
        	text: 'Wizzard!'
        })
        var topPanel=Ext.create('Ext.panel.Panel', {
        	border:false,
        	items:[this.topIndicator],
        	padding: '10 0 0 10',
        	height:40
        });
        
        Ext.apply(me, {
            items : [{
                xtype : 'panel',
                items : insideItems,
                border : 0,
                dockedItems: [{
                    xtype: 'toolbar',
                    dock: 'bottom',
                    ui: 'footer',
                    defaults: {minWidth: 75},
                    items: oButtons
                }, {
                	dock:'left',
                	items: this.leftPanel
                }, {
                	dock:'top',
                	items: topPanel
                }]
            } ]
        }); // Ext.apply

        this.callParent(arguments);

    },
    startWizard: function () {
    	this.show();
    	if (this.oStartPage!=null)
    		this.setStep(-1);
    	else
    		this.setStep(0);    	
    },
    setStep: function (selIndex) {
    	this.actIndex=selIndex;
    	if (this.oStartPage!=null)
    		this.oStartPage.setVisible(selIndex==-1)
    	for (var iIndex=0;iIndex<this.oPages.length;iIndex++)
    		this.oPages[iIndex].setVisible(iIndex==selIndex);

    	this.buttonStart.setVisible(selIndex==-1);
    	this.buttonNext.setVisible((selIndex<(this.oPages.length-1)) && (selIndex>=0));
    	this.buttonFinish.setVisible(selIndex==(this.oPages.length-1));
    	this.buttonCancel.setVisible(false);
    	this.buttonBack.setVisible(selIndex>0);
    	
    	if (selIndex==-1) {
    		this.topIndicator.setText(this.startLongTitle);
    	} else {
    		this.topIndicator.setText(this.pageDefinition[selIndex].longTitle);
    	}
    	this.validatePage();

    	var pageDef=this.pageDefinition[this.actIndex];
    	for (var iIndex=0;iIndex<pageDef.controls.length;iIndex++) {
    		var id=pageDef.controls[iIndex].id;
    		this.editControls[id].setValue(this.value[id],this.value);
    	}    	
    }
    /*,

    setValues : function(orgValues) {
    	var values=Ext.JSON.decode(Ext.JSON.encode(orgValues));
        if (values == null) {
            for ( var sKey in this.editControls) {
            	try {
	                if (this.editControls[sKey].reset != null)
	                    this.editControls[sKey].reset();
	                else if (this.editControls[sKey].resetComponent != null)
	                    this.editControls[sKey].resetComponent();
            	}
            	catch (e) {}
            }
        } else {
            for ( var sKey in this.editControls) {
            	try {
            		if (this.oTabPanelParent != null)
	                    if (this.editControls[sKey]._myTabIndex != -1) {
	                        this.oTabPanelParent.doLayout();
	                        this.oTabPanelParent.setActiveTab(this.editControls[sKey]._myTabIndex);
	                    }
	                if (values[sKey] != null) {
	                    this.editControls[sKey].setValue(values[sKey]);
	                } else {
	                    if (this.editControls[sKey].reset != null)
	                        this.editControls[sKey].reset();
	                    else if (this.editControls[sKey].resetComponent != null)
	                        this.editControls[sKey].resetComponent();
	                }
                }
            	catch (e) {}
            }
        }
        if (this.oTabPanelParent != null) {
        	if (orgValues==null) {
        		this.oTabPanelParent.setActiveTab(this.defaultFirstTabOnNew);
        	} else {
        		this.oTabPanelParent.setActiveTab(this.defaultFirstTabOnEdit);
        	}            
            for ( var sKey in this.oTabPanels) {
                this.oTabPanels[sKey].panel.setTitle(this.oTabPanels[sKey].title);
            }

        }
    }, // resetComponent

    isValid : function() {
        var fisValid = true;
        for (var sKey in this.oTabPanels)
            this.oTabPanels[sKey].panel.setTitle(this.oTabPanels[sKey].title);
        
        for ( var sKey in this.editControls) {
            if (!this.editControls[sKey].isValid()) {
                fisValid = false;
                if (this.editControls[sKey]._myTabIndex!=-1)
                    this.oTabPanels["" + this.editControls[sKey]._myTabIndex].panel.setTitle('<span style="color:#ff0000;">' + this.oTabPanels["" + this.editControls[sKey]._myTabIndex].title + '</span>');
            }
        }
        return fisValid;
    },

    getValues : function() {
        var oValues = {};
        for ( var sKey in this.editControls) {
            oValues[sKey] = this.editControls[sKey].getValue();
        }
        return oValues;
    },
    enableControl : function(sControl,fEnable) {
        if (this.editControls[sControl]!=null)
            this.editControls[sControl].setDisabled(!fEnable);
    }*/
});

